// Code generated by protoc-gen-grpc-gateway. DO NOT EDIT.
// source: phxservices/services/ios/v1/ios_service.proto

/*
Package v1 is a reverse proxy.

It translates gRPC into RESTful JSON APIs.
*/
package v1

import (
	"context"
	"io"
	"net/http"

	"github.com/grpc-ecosystem/grpc-gateway/v2/runtime"
	"github.com/grpc-ecosystem/grpc-gateway/v2/utilities"
	"google.golang.org/grpc"
	"google.golang.org/grpc/codes"
	"google.golang.org/grpc/grpclog"
	"google.golang.org/grpc/metadata"
	"google.golang.org/grpc/status"
	"google.golang.org/protobuf/proto"
)

// Suppress "imported and not used" errors
var _ codes.Code
var _ io.Reader
var _ status.Status
var _ = runtime.String
var _ = utilities.NewDoubleArray
var _ = metadata.Join

var (
	filter_IOSProductService_GetProductDetails_0 = &utilities.DoubleArray{Encoding: map[string]int{"upc": 0}, Base: []int{1, 1, 0}, Check: []int{0, 1, 2}}
)

func request_IOSProductService_GetProductDetails_0(ctx context.Context, marshaler runtime.Marshaler, client IOSProductServiceClient, req *http.Request, pathParams map[string]string) (proto.Message, runtime.ServerMetadata, error) {
	var protoReq GetProductDetailsRequest
	var metadata runtime.ServerMetadata

	var (
		val string
		ok  bool
		err error
		_   = err
	)

	val, ok = pathParams["upc"]
	if !ok {
		return nil, metadata, status.Errorf(codes.InvalidArgument, "missing parameter %s", "upc")
	}

	if protoReq.ProductReference == nil {
		protoReq.ProductReference = &GetProductDetailsRequest_Upc{}
	} else if _, ok := protoReq.ProductReference.(*GetProductDetailsRequest_Upc); !ok {
		return nil, metadata, status.Errorf(codes.InvalidArgument, "expect type: *GetProductDetailsRequest_Upc, but: %t\n", protoReq.ProductReference)
	}
	protoReq.ProductReference.(*GetProductDetailsRequest_Upc).Upc, err = runtime.String(val)
	if err != nil {
		return nil, metadata, status.Errorf(codes.InvalidArgument, "type mismatch, parameter: %s, error: %v", "upc", err)
	}

	if err := req.ParseForm(); err != nil {
		return nil, metadata, status.Errorf(codes.InvalidArgument, "%v", err)
	}
	if err := runtime.PopulateQueryParameters(&protoReq, req.Form, filter_IOSProductService_GetProductDetails_0); err != nil {
		return nil, metadata, status.Errorf(codes.InvalidArgument, "%v", err)
	}

	msg, err := client.GetProductDetails(ctx, &protoReq, grpc.Header(&metadata.HeaderMD), grpc.Trailer(&metadata.TrailerMD))
	return msg, metadata, err

}

func local_request_IOSProductService_GetProductDetails_0(ctx context.Context, marshaler runtime.Marshaler, server IOSProductServiceServer, req *http.Request, pathParams map[string]string) (proto.Message, runtime.ServerMetadata, error) {
	var protoReq GetProductDetailsRequest
	var metadata runtime.ServerMetadata

	var (
		val string
		ok  bool
		err error
		_   = err
	)

	val, ok = pathParams["upc"]
	if !ok {
		return nil, metadata, status.Errorf(codes.InvalidArgument, "missing parameter %s", "upc")
	}

	if protoReq.ProductReference == nil {
		protoReq.ProductReference = &GetProductDetailsRequest_Upc{}
	} else if _, ok := protoReq.ProductReference.(*GetProductDetailsRequest_Upc); !ok {
		return nil, metadata, status.Errorf(codes.InvalidArgument, "expect type: *GetProductDetailsRequest_Upc, but: %t\n", protoReq.ProductReference)
	}
	protoReq.ProductReference.(*GetProductDetailsRequest_Upc).Upc, err = runtime.String(val)
	if err != nil {
		return nil, metadata, status.Errorf(codes.InvalidArgument, "type mismatch, parameter: %s, error: %v", "upc", err)
	}

	if err := req.ParseForm(); err != nil {
		return nil, metadata, status.Errorf(codes.InvalidArgument, "%v", err)
	}
	if err := runtime.PopulateQueryParameters(&protoReq, req.Form, filter_IOSProductService_GetProductDetails_0); err != nil {
		return nil, metadata, status.Errorf(codes.InvalidArgument, "%v", err)
	}

	msg, err := server.GetProductDetails(ctx, &protoReq)
	return msg, metadata, err

}

// RegisterIOSProductServiceHandlerServer registers the http handlers for service IOSProductService to "mux".
// UnaryRPC     :call IOSProductServiceServer directly.
// StreamingRPC :currently unsupported pending https://github.com/grpc/grpc-go/issues/906.
// Note that using this registration option will cause many gRPC library features to stop working. Consider using RegisterIOSProductServiceHandlerFromEndpoint instead.
func RegisterIOSProductServiceHandlerServer(ctx context.Context, mux *runtime.ServeMux, server IOSProductServiceServer) error {

	mux.Handle("GET", pattern_IOSProductService_GetProductDetails_0, func(w http.ResponseWriter, req *http.Request, pathParams map[string]string) {
		ctx, cancel := context.WithCancel(req.Context())
		defer cancel()
		var stream runtime.ServerTransportStream
		ctx = grpc.NewContextWithServerTransportStream(ctx, &stream)
		inboundMarshaler, outboundMarshaler := runtime.MarshalerForRequest(mux, req)
		rctx, err := runtime.AnnotateIncomingContext(ctx, mux, req, "/phxservices.services.ios.v1.IOSProductService/GetProductDetails", runtime.WithHTTPPathPattern("/api/v1/productDetails/{upc}"))
		if err != nil {
			runtime.HTTPError(ctx, mux, outboundMarshaler, w, req, err)
			return
		}
		resp, md, err := local_request_IOSProductService_GetProductDetails_0(rctx, inboundMarshaler, server, req, pathParams)
		md.HeaderMD, md.TrailerMD = metadata.Join(md.HeaderMD, stream.Header()), metadata.Join(md.TrailerMD, stream.Trailer())
		ctx = runtime.NewServerMetadataContext(ctx, md)
		if err != nil {
			runtime.HTTPError(ctx, mux, outboundMarshaler, w, req, err)
			return
		}

		forward_IOSProductService_GetProductDetails_0(ctx, mux, outboundMarshaler, w, req, resp, mux.GetForwardResponseOptions()...)

	})

	return nil
}

// RegisterIOSProductServiceHandlerFromEndpoint is same as RegisterIOSProductServiceHandler but
// automatically dials to "endpoint" and closes the connection when "ctx" gets done.
func RegisterIOSProductServiceHandlerFromEndpoint(ctx context.Context, mux *runtime.ServeMux, endpoint string, opts []grpc.DialOption) (err error) {
	conn, err := grpc.Dial(endpoint, opts...)
	if err != nil {
		return err
	}
	defer func() {
		if err != nil {
			if cerr := conn.Close(); cerr != nil {
				grpclog.Infof("Failed to close conn to %s: %v", endpoint, cerr)
			}
			return
		}
		go func() {
			<-ctx.Done()
			if cerr := conn.Close(); cerr != nil {
				grpclog.Infof("Failed to close conn to %s: %v", endpoint, cerr)
			}
		}()
	}()

	return RegisterIOSProductServiceHandler(ctx, mux, conn)
}

// RegisterIOSProductServiceHandler registers the http handlers for service IOSProductService to "mux".
// The handlers forward requests to the grpc endpoint over "conn".
func RegisterIOSProductServiceHandler(ctx context.Context, mux *runtime.ServeMux, conn *grpc.ClientConn) error {
	return RegisterIOSProductServiceHandlerClient(ctx, mux, NewIOSProductServiceClient(conn))
}

// RegisterIOSProductServiceHandlerClient registers the http handlers for service IOSProductService
// to "mux". The handlers forward requests to the grpc endpoint over the given implementation of "IOSProductServiceClient".
// Note: the gRPC framework executes interceptors within the gRPC handler. If the passed in "IOSProductServiceClient"
// doesn't go through the normal gRPC flow (creating a gRPC client etc.) then it will be up to the passed in
// "IOSProductServiceClient" to call the correct interceptors.
func RegisterIOSProductServiceHandlerClient(ctx context.Context, mux *runtime.ServeMux, client IOSProductServiceClient) error {

	mux.Handle("GET", pattern_IOSProductService_GetProductDetails_0, func(w http.ResponseWriter, req *http.Request, pathParams map[string]string) {
		ctx, cancel := context.WithCancel(req.Context())
		defer cancel()
		inboundMarshaler, outboundMarshaler := runtime.MarshalerForRequest(mux, req)
		rctx, err := runtime.AnnotateContext(ctx, mux, req, "/phxservices.services.ios.v1.IOSProductService/GetProductDetails", runtime.WithHTTPPathPattern("/api/v1/productDetails/{upc}"))
		if err != nil {
			runtime.HTTPError(ctx, mux, outboundMarshaler, w, req, err)
			return
		}
		resp, md, err := request_IOSProductService_GetProductDetails_0(rctx, inboundMarshaler, client, req, pathParams)
		ctx = runtime.NewServerMetadataContext(ctx, md)
		if err != nil {
			runtime.HTTPError(ctx, mux, outboundMarshaler, w, req, err)
			return
		}

		forward_IOSProductService_GetProductDetails_0(ctx, mux, outboundMarshaler, w, req, resp, mux.GetForwardResponseOptions()...)

	})

	return nil
}

var (
	pattern_IOSProductService_GetProductDetails_0 = runtime.MustPattern(runtime.NewPattern(1, []int{2, 0, 2, 1, 2, 2, 1, 0, 4, 1, 5, 3}, []string{"api", "v1", "productDetails", "upc"}, ""))
)

var (
	forward_IOSProductService_GetProductDetails_0 = runtime.ForwardResponseMessage
)
